<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="admin" tagdir="/WEB-INF/tags/admin" %>
<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms" %>
<%@ taglib prefix="l" tagdir="/WEB-INF/tags/layout" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<jsp:useBean id="propertiesBean" scope="request" type="jetbrains.buildServer.controllers.BasePropertiesBean"/>

<forms:workingDirectory />

<tr>
  <th>
    <label for="use.custom.script">Run: </label>
  </th>
  <td>
    <c:set var='onchange'>
      if (this.options[this.selectedIndex].value == 'true') {
      BS.Util.hide($('command.executable.container'));
      BS.Util.hide($('command.parameters.container'));
      BS.Util.show($('script.content.container'));
      BS.MultilineProperties.show('script.content', true);
      $('script.content').focus();
      } else {
      BS.Util.show($('command.executable.container'));
      BS.Util.show($('command.parameters.container'));
      BS.Util.hide($('script.content.container'));
      $('command.executable').focus();
      }
      BS.VisibilityHandlers.updateVisibility($('mainContent'));
    </c:set>
    <props:selectProperty name="use.custom.script" onchange="${onchange}">
      <props:option value="" selected="${empty propertiesBean.properties['use.custom.script']}">Executable with parameters</props:option>
      <props:option value="true" selected="${not empty propertiesBean.properties['use.custom.script']}">Custom script</props:option>
    </props:selectProperty>
  </td>
</tr>

<tr id="command.executable.container" style="${not empty propertiesBean.properties['use.custom.script'] ? 'display:none;' : ''}">
  <th>
    <label for="command.executable">Command executable: </label> <l:star/>
  </th>
  <td>
    <props:textProperty name="command.executable"  className="longField"/>
    <span class="error" id="error_command.executable"></span>
  </td>
</tr>
<tr id="command.parameters.container" style="${not empty propertiesBean.properties['use.custom.script'] ? 'display:none;' : ''}">
  <th>
    <label for="use.custom.script.false">Command parameters: </label>
  </th>
  <td>
  <props:textProperty name="command.parameters"  className="longField"/>
  </td>
</tr>
<tr id="script.content.container" style="${not empty propertiesBean.properties['use.custom.script'] ? '' : 'display:none;'}">
  <th>
    <label for="script.content">Custom script: </label> <l:star/>
  </th>
  <td>
    <props:multilineProperty name="script.content" rows="10" cols="58" expanded="true" linkTitle="Type the build script content"/>
    <span class="error" id="error_script.content"></span>
    <span class="smallNote">Platform specific script which will be executed as *.cmd file on Windows or as an executable script in Unix-like environments.</span>
  </td>
</tr>